HDU 1058 Humble Numbers (DP)

Humble Numbers

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 18238    Accepted Submission(s): 7934

Problem Description

A number whose only prime factors are 2,3,5 or 7 is called a humble number. The sequence 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 14, 15, 16, 18, 20, 21, 24, 25, 27, ... shows the first 20 humble numbers.

Write a program to find and print the nth element in this sequence

Input

The input consists of one or more test cases. Each test case consists of one integer n with 1 <= n <= 5842. Input is terminated by a value of zero (0) for n.

Output

For each test case, print one line saying "The nth humble number is number.". Depending on the value of n, the correct suffix "st", "nd", "rd", or "th" for the ordinal number nth has to be used like it is shown in the sample output.

Sample Input

1
2
3
4
11
12
13
21
22
23
100
1000
5842
0

Sample Output

The 1st humble number is 1.
The 2nd humble number is 2.
The 3rd humble number is 3.
The 4th humble number is 4.
The 11th humble number is 12.
The 12th humble number is 14.
The 13th humble number is 15.
The 21st humble number is 28.
The 22nd humble number is 30.
The 23rd humble number is 32.
The 100th humble number is 450.
The 1000th humble number is 385875.
The 5842nd humble number is 2000000000.

说DP有点牵强,不过也算是用前面的状态推出后面的状态,英语知识是个易错点。

思路:2,5,7,9是丑数,丑数的2,5,7,9倍也是丑数,所以从1开始,对每个数计算计算它的2,5,7,9倍,算出来的结果又再翻倍。难免会遇到这种考察其它乱七八糟的知识点的题,输出时的后缀很容易错,在英语里如果一个数的个位是1,那后面跟st,2跟nd,3跟rd,其它跟th,但是注意,后面两位是11,12,13的除外,这些数后面都跟th,比如12,10013,1111,我WA了三次,算是英语差的后果吧。

 1 #include<stdio.h>
 2 #include<string.h>
 3 #include<stdlib.h>
 4 #define    MAX    5845
 5
 6 int    my_min(int a,int b,int c,int d);
 7 int    main(void)
 8 {
 9     int    n;
10     int    s[MAX] = {1};
11     int    i,i_2,i_3,i_5,i_7;
12     int    box,box_2,box_3,box_5,box_7;
13     char    cha[5];
14     i = i_2 = i_3 = i_5 = i_7 = 0;
15
16     while(i < MAX - 2)
17     {
18         box_2 = s[i_2] * 2;
19         box_3 = s[i_3] * 3;
20         box_5 = s[i_5] * 5;
21         box_7 = s[i_7] * 7;
22
23         box = my_min(box_2,box_3,box_5,box_7);    //每次把最小的那个插入到数组里,就不用排序了
24         if(box == box_2)            //要一直用if,因为结果可能相同
25             i_2 ++;
26         if(box == box_3)
27             i_3 ++;
28         if(box == box_5)
29             i_5 ++;
30         if(box == box_7)
31             i_7 ++;
32
33         i ++;
34         s[i] = box;
35     }
36
37     while(scanf("%d",&n) && n)
38     {
39         box = n % 100;
40         if(box == 11 || box == 12 || box == 13)
41         {
42             strcpy(cha,"th");
43             goto    label;
44         }
45
46         box = n;
47         while(box / 10)
48             box %= 10;
49         switch(box % 10)
50         {
51             case    1:strcpy(cha,"st");break;
52             case    2:strcpy(cha,"nd");break;
53             case    3:strcpy(cha,"rd");break;
54             default     :strcpy(cha,"th");break;
55         }
56
57         label:
58         printf("The %d%s humble number is %d.\n",n,cha,s[n - 1]);
59     }
60
61     return    0;
62 }
63
64 int    my_min(int a,int b,int c,int d)
65 {
66     int    min = a;
67
68     min = min < b ? min : b;
69     min = min < c ? min : c;
70     min = min < d ? min : d;
71
72     return    min;
73 }
时间: 2024-12-17 14:14:27

HDU 1058 Humble Numbers (DP)的相关文章

HDU 1058 Humble Numbers (dp+打表)

先是想筛法素数表啊,然后1~2000000000枚举打表啊,结果越想越不对. 后来想到唯一分解定理,可是怎么实现呢..果然还是需要努力啊.. 研究了discuss代码,码之~ ~~~~ dp的思想,若dp[i]是Humble Numbers,那么dp[i]*2,dp[i]*3,dp[i]*5,dp[i]*7都将是Humble Numbers. 所以只需要注意连续性便好了. #include<cstdio> #include<algorithm> #include<cmath&

HDU 1058 Humble Numbers(DP,数)

题意  所有只能被2,3,5,7这4个素数整除的数称为Humble Number  输入n  输出第n个Humble Number 1是第一个humble number  对于一个Humble Number  a  有2*a,3*a,5*a,7*a都是Humble Number  可以以1为基数  依次展开即可得到一定范围内的Humble Number 用i,j,k,l分别记录 2,3,5,7分别乘到了第几个Humble Number  当前在计算第cnt个Humble Number  那么有

HDU 1058 Humble Numbers (打表)

题目链接:HDU 1058 Humble Numbers 题意:一些数他们的素数因子只有2,3,5,7.求这些数. 因为这些数的因子只可能是2,3,5,7.所以通过2,3,5,7这个四个数构造这个数列,这个数列靠后的数必定是前面的数乘上2,3,5,7得到. AC代码: #include<stdio.h> #include<set> #define ll __int64 using namespace std; set<ll> s; set<ll>::iter

HDU 1058 Humble Numbers &amp;&amp; NOJ 1420 丑数 (数位dp)

Humble Numbers                          Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)                                          Total Submission(s): 18555    Accepted Submission(s): 8080 Problem Description A numb

hdu 1058 Humble Numbers || poj 1338(dp)

两题都是一样的题目 只是hdu 1058 多了个7 题意:求一个每个数因子仅含2 3 5 7 的 序列 问 第n个数是几 思路: ans[i]=min(min(ans[n2]*2,ans[n3]*3),min(ans[n5]*5,ans[n7]*7)); if(ans[i]==ans[n2]*2) n2++; if(ans[i]==ans[n3]*3) n3++; if(ans[i]==ans[n5]*5) n5++; if(ans[i]==ans[n7]*7) n7++; hdu 1058 #

HDU 1058 Humble Numbers(dp)

Problem Description A number whose only prime factors are 2,3,5 or 7 is called a humble number. The sequence 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 14, 15, 16, 18, 20, 21, 24, 25, 27, ... shows the first 20 humble numbers. Write a program to find and pri

HDU 1058.Humble Numbers【这个题怎么定位呢&#183;&#183;&#183;就【DP】吧】【8月28】

Humble Numbers Problem Description A number whose only prime factors are 2,3,5 or 7 is called a humble number. The sequence 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 14, 15, 16, 18, 20, 21, 24, 25, 27, ... shows the first 20 humble numbers. Write a program

HDU 1058 Humble Numbers (动规+寻找丑数问题)

Humble Numbers Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 16742    Accepted Submission(s): 7280 Problem Description A number whose only prime factors are 2,3,5 or 7 is called a humble numb

hdu 1058 Humble Numbers

Humble Numbers Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 18406    Accepted Submission(s): 8010 Problem Description A number whose only prime factors are 2,3,5 or 7 is called a humble numbe